<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/ButtonsCommanderPotentiometer.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('ButtonsCommanderPotentiometer_8cpp_source.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">ButtonsCommanderPotentiometer.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*************************************************************</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">project: &lt;Commanders&gt;</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">author: &lt;Thierry PARIS&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">description: &lt;Potentiometer returning a current value.&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">*************************************************************/</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="Commanders_8h.html">Commanders.h</a>&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef NO_BUTTONSCOMMANDER</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef NO_BUTTONSCOMMANDERPOTENTIOMETER</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="classButtonsCommanderPotentiometer.html#aa44cfe02705e00e1a0c4ad842132b3ba">   11</a></span>&#160;<a class="code" href="classButtonsCommanderPotentiometer.html#aa44cfe02705e00e1a0c4ad842132b3ba">ButtonsCommanderPotentiometer::ButtonsCommanderPotentiometer</a>() : <a class="code" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a>(<a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>)</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;}</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="classButtonsCommanderPotentiometer.html#a44442eceb7a1091bbaa84ada1475487a">   15</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classButtonsCommanderPotentiometer.html#a44442eceb7a1091bbaa84ada1475487a">ButtonsCommanderPotentiometer::begin</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <span class="keywordtype">int</span> inPin, <span class="keywordtype">int</span> inMinimum, <span class="keywordtype">int</span> inMaximum, <span class="keywordtype">int</span> inMoveAccuracy)</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;{</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    this-&gt;<a class="code" href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">Id</a> = inId;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    this-&gt;mini = inMinimum;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    this-&gt;maxi = inMaximum;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    this-&gt;pin = inPin;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    this-&gt;moveAccuracy = inMoveAccuracy - 1;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keywordflow">if</span> (this-&gt;moveAccuracy &lt;= 0)</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        this-&gt;moveAccuracy = 1;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keywordtype">int</span> val = analogRead(this-&gt;pin);</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    this-&gt;currentValue = map(val, 0, 1023, this-&gt;mini, this-&gt;maxi);</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;}</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="classButtonsCommanderPotentiometer.html#a64f51252b6a09664897197989ec87a08">   29</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classButtonsCommanderPotentiometer.html#a64f51252b6a09664897197989ec87a08">ButtonsCommanderPotentiometer::loop</a>()</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;{</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_DEBUG_MODE</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">Id</a> == <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>)</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;This potentiometer have no ID defined : call begin() !&quot;</span>));</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">int</span> val = analogRead(this-&gt;pin);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    val = map(val, 0, 1023, this-&gt;mini, this-&gt;maxi);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordflow">if</span> (val &lt; this-&gt;currentValue - this-&gt;moveAccuracy || val &gt; this-&gt;currentValue + this-&gt;moveAccuracy)</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    {</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_DEBUG_MODE</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        Serial.print(F(<span class="stringliteral">&quot;Potentiometer new value : &quot;</span>));</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        Serial.println(val, DEC);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        this-&gt;currentValue = val;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a>(this-&gt;<a class="code" href="classButtonsCommanderButton.html#acbdd1d63fed7736c7358105428fbfd9c">GetId</a>(), <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490ca820fe8d0aad337114732954c5965e82b">COMMANDERS_EVENT_MOVEPOSITION</a>, val);</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    }</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;}</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_PRINT_COMMANDERS</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="keywordtype">void</span> ButtonsCommanderPotentiometer::printCommander()</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;{</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;    Potentiometer - Pin:&quot;</span>));</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    Serial.print(this-&gt;pin);</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    Serial.print(F(<span class="stringliteral">&quot; / Mini: &quot;</span>));</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    Serial.print(this-&gt;mini);</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    Serial.print(F(<span class="stringliteral">&quot; / Maxi: &quot;</span>));</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    Serial.print(this-&gt;maxi);</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    Serial.print(F(<span class="stringliteral">&quot; / Accuracy: &quot;</span>));</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    Serial.println(this-&gt;moveAccuracy);</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;}</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="Events_8h_html_a36239a7eea6194f04e73e80d7419490ca820fe8d0aad337114732954c5965e82b"><div class="ttname"><a href="Events_8h.html#a36239a7eea6194f04e73e80d7419490ca820fe8d0aad337114732954c5965e82b">COMMANDERS_EVENT_MOVEPOSITION</a></div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00030">Events.h:30</a></div></div>
<div class="ttc" id="classCommanders_html_a7adbe54da67e90e0d39b58d69ac3add0"><div class="ttname"><a href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a></div><div class="ttdeci">static unsigned long RaiseEvent(unsigned long inId, COMMANDERS_EVENT_TYPE inEvent = COMMANDERS_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Commanders_8cpp_source.html#l00027">Commanders.cpp:27</a></div></div>
<div class="ttc" id="classButtonsCommanderButton_html_acbdd1d63fed7736c7358105428fbfd9c"><div class="ttname"><a href="classButtonsCommanderButton.html#acbdd1d63fed7736c7358105428fbfd9c">ButtonsCommanderButton::GetId</a></div><div class="ttdeci">unsigned long GetId() const </div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderButton_8hpp_source.html#l00030">ButtonsCommanderButton.hpp:30</a></div></div>
<div class="ttc" id="classButtonsCommanderPotentiometer_html_a64f51252b6a09664897197989ec87a08"><div class="ttname"><a href="classButtonsCommanderPotentiometer.html#a64f51252b6a09664897197989ec87a08">ButtonsCommanderPotentiometer::loop</a></div><div class="ttdeci">unsigned long loop()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPotentiometer_8cpp_source.html#l00029">ButtonsCommanderPotentiometer.cpp:29</a></div></div>
<div class="ttc" id="classButtonsCommanderButton_html_a3b40667770ab04694a2ea85f11aebfe0"><div class="ttname"><a href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">ButtonsCommanderButton::Id</a></div><div class="ttdeci">unsigned long Id</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderButton_8hpp_source.html#l00019">ButtonsCommanderButton.hpp:19</a></div></div>
<div class="ttc" id="classButtonsCommanderPotentiometer_html_a44442eceb7a1091bbaa84ada1475487a"><div class="ttname"><a href="classButtonsCommanderPotentiometer.html#a44442eceb7a1091bbaa84ada1475487a">ButtonsCommanderPotentiometer::begin</a></div><div class="ttdeci">void begin(unsigned long inId, int inPin, int inMinimum, int inMaximum, int inMoveAccuracy = 1)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPotentiometer_8cpp_source.html#l00015">ButtonsCommanderPotentiometer.cpp:15</a></div></div>
<div class="ttc" id="Events_8h_html_a48ad4dd16b8e22f2c8bc92b154479e92"><div class="ttname"><a href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a></div><div class="ttdeci">#define UNDEFINED_ID</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00038">Events.h:38</a></div></div>
<div class="ttc" id="classButtonsCommanderButton_html"><div class="ttname"><a href="classButtonsCommanderButton.html">ButtonsCommanderButton</a></div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderButton_8hpp_source.html#l00015">ButtonsCommanderButton.hpp:15</a></div></div>
<div class="ttc" id="classButtonsCommanderPotentiometer_html_aa44cfe02705e00e1a0c4ad842132b3ba"><div class="ttname"><a href="classButtonsCommanderPotentiometer.html#aa44cfe02705e00e1a0c4ad842132b3ba">ButtonsCommanderPotentiometer::ButtonsCommanderPotentiometer</a></div><div class="ttdeci">ButtonsCommanderPotentiometer()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPotentiometer_8cpp_source.html#l00011">ButtonsCommanderPotentiometer.cpp:11</a></div></div>
<div class="ttc" id="Commanders_8h_html"><div class="ttname"><a href="Commanders_8h.html">Commanders.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>ButtonsCommanderPotentiometer.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
